<?php
# 缓存配置，一共有四级缓存：mysql数据库缓存、data数据缓存、html页面模板缓存、load加载器缓存
return array
(
	# 启用mysql数据库缓存，这个缓存是根据表名自动生成，dever::load形式和service的all、one形式均自动支持，无需手动添加
	'mysql' => 0,
	# 启用页面缓存 会根据当前的url来生成缓存，相当于页面静态化。
	'html' => 0,
	# 启用数据级别缓存 这个缓存是程序员自定义的：Dever::cache('name', 'value', 3600);
	'data' => 3600,
	# 启用load加载器缓存
	'load' => 3600,

	# 缓存精细控制，可以根据缓存的key（mysql为表名、service为小写类名，规则是模糊匹配），来控制每一条缓存
	'load_key' => array
	(
		# 定义缓存名为auth.data的缓存时间
		'auth.data' => 200,
	),
	
	# 缓存清理的参数名，值为clear
	'clear' => 'dever_cache',

	# 是否启用key失效时间记录，启用之后，将会记录每个key的失效时间
	'expire' => true,

	# 缓存类型
	'type' => 'memcache',//memcache、redis

	# 缓存保存方式，支持多个数据源、多台缓存服务器
	'store' => array
	(
		array
		(
			'host' => '127.0.0.1',
			'port' => '11211',
			'weight' => 100,
		),

		/*
		array
		(
			'host' => '127.0.0.1',
			'port' => '11212',
			'weight' => 100,
		),
		*/
	),
);
