<?php namespace Dever\Config;

use Dever\Config\Lang;
use Dever\Http\Output;

class Load
{
    /**
     * env
     *
     * @var const string
     */
    const ENV = 'env';

    /**
     * global
     *
     * @var array
     */
    static public $global;

    /**
     * object
     *
     * @var object
     */
    static public $object;

    /**
     * init
     *
     * @return mixed
     */
    static public function init()
    {
        self::get('base');
    }

    /**
     * get
     * @param string $name
     * @param string $path
     * @param string $project
     *
     * @return mixed
     */
    static public function get($name = 'host', $project = '', $path = 'config')
    {
        self::server();

        if($project)
        {
            $index = $project . '_' . $path . '_' . $name;
        }
        else
        {
            $index = $name;
        }

        if(empty(self::$global[$index]))
        {
            $root = DEVER_APP_PATH;
            $name = DEVER_APP_NAME;
            if($project)
            {
                $project = Project::load($project);
                $root = $project['path'];
                $name = $project['name'];
            }

            $config = array(DEVER_PATH, $root);
            //$config = array(DEVER_PATH, $root, DEVER_PATH . 'data/' . $project . '/');

            self::$global[$index] = array();

            foreach($config as $k => $v)
            {
                self::assign($name, $v . $path . '/', $index);
            }

            if($name != $index)
            {
                self::$global[$name] = self::$global[$index];
            }
        }

        if(empty(self::$global[$index]))
        {
            Output::abert('file_exists', $name);
        }
        
        return self::$global[$index];
    }

    /**
     * object
     * @param string $name
     *
     * @var array
     */
    static private function object($name, $project = '', $path = 'config')
    {
        if($project)
        {
            $index = $project . '_' . $path . '_' . $name;
        }
        else
        {
            $index = $name;
        }

        if(isset(self::$object[$index]))
        {
            return self::$object[$index];
        }

        self::$object[$index] = (object) self::$global[$index];

        if($name != $index)
        {
            self::$object[$name] = self::$object[$index];
        }

        return self::$object[$index];
    }

    /**
     * server
     *
     * @var mixed
     */
    static private function server()
    {
        if(empty($_SERVER['DEVER_SERVER']))
        {
            if(isset($_SERVER['SERVER_NAME']))
            {
                $_SERVER['DEVER_SERVER'] = $_SERVER['SERVER_NAME'];
            }
            else
            {
                $_SERVER['DEVER_SERVER'] = 'localhost';
            }
        }

        if(strpos($_SERVER['DEVER_SERVER'], '*.') !== false)
        {
            $_SERVER['DEVER_SERVER'] = str_replace('*.', '', $_SERVER['DEVER_SERVER']);
        }
    }

    /**
     * env
     * @param string $name
     * @param string $path
     * @param string $index
     *
     * @var array
     */
    static private function env($name, $path, $index)
    {
        $config[] = 'default';
        if($name != 'base')
        {
            $config[] = $name;
        }
        foreach($config as $k => $v)
        {
            self::assign($v, $path . self::ENV . '/' . $_SERVER['DEVER_SERVER'] . '/', $index);
        }
    }

    /**
     * assign
     * @param string $name
     * @param string $path
     * @param string $index
     *
     * @var array
     */
    static private function assign($name, $path, $index)
    {
        $file = $path . $name . '.php';

        if(is_file($file))
        {
            if($name == 'base')
            {
                self::env($name, $path, $index);
            }
            $config = include($file);
            
            if(is_array($config))
            {
                self::$global[$index] = array_merge(self::$global[$index], $config);
            }
        }
    }

    /**
     * env
     *
     * @var string
     */
    static public function data()
    {
        return isset(self::$global['base']['data']) ? self::$global['base']['data'] : DEVER_PATH . 'data/';
    }
}