<?php namespace Dever\Config;

use Dever\Http\Url;
use Dever\Config\Load as Config;

class Project
{
	static private $content;

	static private $alias;

	static public function content($update = false)
	{
		$file = Config::data() . 'project/' . DEVER_PROJECT . '.php';
		
		if(self::$content && $update == false)
		{
			return $file;
		}

		self::$content = $poject = $alias = array();
		
		if(is_file($file))
		{
			require $file;

			self::$content = $project;

			self::$alias = $alias;
		}

		return $file;
	}

	static public function register()
	{
		$file = self::content();

		if(empty(self::$content[DEVER_APP_NAME]))
		{
			self::init();

			file_put_contents($file, '<?php $project = ' . var_export(self::$content, true) . ';$alias = ' . self::getAlias() . ';');
			
			# 加入后台菜单
			if(self::load('manage') && \Dever\Routing\Load::get('manage/auth.data'))
			{
				\Dever\Routing\Load::get('manage/menu.load');
			}
		}
		elseif(isset(self::$content[DEVER_APP_NAME]) && self::$content[DEVER_APP_NAME]['path'] != DEVER_APP_PATH && isset(Load::$global['host']['base']) && Load::$global['host']['base'])
		{
			self::update(DEVER_APP_NAME, 'path', DEVER_APP_PATH);
			self::update(DEVER_APP_NAME, 'url', Load::$global['host']['base']);
			if(defined('DEVER_APP_SETUP'))
			{
				self::update(DEVER_APP_NAME, 'setup', DEVER_APP_SETUP);
			}
			self::content(true);
			//\Dever\Http\Output::abert('project_already_exists', DEVER_APP_NAME);
		}
	}

	static private function init()
	{
		self::$content[DEVER_APP_NAME] = array
		(
			'name' => DEVER_APP_NAME,
			'path' => DEVER_APP_PATH,
			'url' => Load::$global['host']['base'],
			'lang' => defined('DEVER_APP_LANG') ? DEVER_APP_LANG : DEVER_APP_NAME, 
			'order' => defined('DEVER_APP_ORDER') ? DEVER_APP_ORDER : 1, 
			'lib' => defined('DEVER_APP_LIB') ? DEVER_APP_LIB : DEVER_APP_NAME,
			'icon' => defined('DEVER_APP_ICON') ? DEVER_APP_ICON : ''
		);
		
		if(defined('DEVER_APP_SETUP'))
		{
			self::$content[DEVER_APP_NAME]['setup'] = DEVER_APP_SETUP;
		}

		if(defined('DEVER_INCLUDE_PATH'))
		{
			self::$content[DEVER_APP_NAME]['base'] = DEVER_INCLUDE_PATH;

			$path = DEVER_APP_PATH;
			$base = DEVER_INCLUDE_PATH;
			if(strstr(DEVER_APP_PATH, DEVER_PATH))
			{
				$path = str_replace(DEVER_PATH, '', DEVER_APP_PATH);
			}
			elseif(strstr(DEVER_APP_PATH, Load::$global['base']['path']))
			{
				$temp = explode(Load::$global['base']['path'], DEVER_APP_PATH);
				$base = $temp[0];
				$path = $temp[1];
			}
			self::$content[DEVER_APP_NAME]['rel'] = $path;
		}

		self::setAlias();
	}

	static private function getAlias()
	{
		$alias = array();
		if(self::$alias)
		{
			$alias = str_replace(array("'$", "',"), array("$", ","), var_export(self::$alias, true));
		}
		else
		{
			$alias = var_export(self::$alias, true);
		}

		return $alias;
	}

	static private function setAlias()
	{
		foreach(self::$content as $k => $v)
		{
			if($v['lib'] != $k)
			{
				self::$alias[$v['lib']] = '$project["'.$k.'"]';
			}
		}
	}

	static public function update($key, $index, $value)
	{
		$file = self::content();

		if(isset(self::$content[$key]))
		{
			self::$content[$key][$index] = $value;

			file_put_contents($file, '<?php $project = ' . var_export(self::$content, true) . ';');
		}
	}

	static public function read()
	{
		return self::$content;
	}

	static public function load($project)
	{
		$config = false;
		if(isset(self::$content[$project]))
		{
			$config = self::$content[$project];
		}
		elseif(isset(self::$alias[$project]))
		{
			$config = self::$alias[$project];
		}

		if($config && isset(Config::$global['host']['project'][$project]))
		{
			array_merge($config, Config::$global['host']['project'][$project]);
		}

		return $config;
	}
}