<?php namespace Dever\Http;

use Dever\Config\Lang;
use Dever\Config\Load as Config;
use Dever\Http\Url;
use Dever\Debug\Process as Debug;
use Dever\Page\Main as Page;

class Output
{
	
	static public function result($msg, $print = true, $array = true)
	{
		$json 		= Input::get('json', false);
		$callback 	= Input::get('callback', false);
		$function 	= Input::get('function', false);

		/*
		if(!is_array($msg) && ($callback || $array == true))
		{
			$result = self::msg($msg, array(), 1);
		}
		else
		{
			$result = self::msg($msg, array(), 1);
		}
		*/
		if($array == false)
		{
			$result = $msg;
		}
		else
		{
			$result = self::msg($msg, array(), 1);
		}

		if(is_array($result))
		{
			//JSON_FORCE_OBJECT
			$result = json_encode($result);
		}
		
		($json != false && is_array($result)) && $result = json_encode($result);
		$callback != false && $callback != '?'	&& $result = $callback . '('.$result.')';
		$function != false  && $result = '<script>parent.'.$function.'('.$result.')'.'</script>';

		if($print == true)
		{
			self::export($result, true);
		}

		return $result;
	}

	/**
     * export
     * @param string $text
     *
     * @return string
     */
	static public function export($text, $exit = false, $return = false)
	{
		if(is_array($text))
		{
			$callback 	= Input::get('callback', false);
			if($callback)
			{
				$content = $callback . '('.json_encode($text).')';
			}
			else
			{
				$content = "<pre>\n";
		        $content .= htmlspecialchars(print_r($text, true));
		        $content .= "\n</pre>\n";
			}

			if($return) return $content;
			print_r($content);
		}
		else
		{
			if($return) return $text;
			echo $text;
		}

		if($exit == true)
		{
			Debug::data();
			
			die;
		}
	}

	/**
     * msg
     * @param string $msg
     *
     * @return string
     */
   static public function msg($msg, $param = array(), $status = 2)
   {
   		$send = array();
   		if(is_array($msg))
   		{
   			$send = $msg;
   		}
   		else
   		{
   			if(is_numeric($msg))
			{
				$send['code'] = $msg;
				$send['msg'] = Lang::get($msg, $param);
			}
			else
			{
				if(is_numeric($param))
				{
					$send['code'] = $param;
					$param = array();
				}
				$send['msg'] = Lang::get($msg, $param);
				if(empty($send['code']))
				{
					$send['status'] = $status;
				}
			}
   		}

		if($status == 1)
		{
			$send['code'] = 1;

			$page = self::page();
			if($page)
			{
				$send['page'] = $page;
			}
		}

		$eof = Input::get('eof');
		if($eof == 1)
		{
			$send['eof'] = 1;
		}

		return $send;
   }

   /**
     * page
     * @param string $msg
     *
     * @return string
     */
	static public function page($method = 'current', $page = array(), $state = true)
	{
		if($state == false)
		{
			Config::$global['page'][$method] = $state;
		}
		if($page)
		{
			Config::$global['page'][$method] = $page;
		}
		elseif(empty(Config::$global['page'][$method]))
		{
			Config::$global['page'][$method] = false;
			$page = Page::getInstance('current');
			$total = $page->total();
			if($total > 0)
			{
				$current = $page->current();
				$all = $page->getAllPage();
				$status = 1;
				if($current >= $all)
				{
					$status = 0;
				}
				Config::$global['page'][$method] = array
				(
					'total' => $total,
					'current_page' => $current,
					'total_page' => $all,
					'next_page' => $page->next(),
					'prev_page' => $page->prev(),
					'html' => $page->get(),
					'status' => $status,
				);
			}
		}

		return Config::$global['page'][$method];
	}
	
	/**
     * out
     * @param string $msg
     *
     * @return string
     */
	static public function abert($msg, $param = array())
	{
		$send = self::msg($msg, $param, 2);

		if($param)
		{
			$send['param'] = $param;
		}
		
		$callback 	= Input::get('callback', false);
		$json 		= Input::get('json', false);
		$function 	= Input::get('function', false);
		
		if($callback || $json || $function || strpos($msg, '_array'))
		{
			self::result($send);
		}
		else
		{
			self::html($send);die;
		}
		//self::export($send, true);
	}
	
	/**
     * out
     * @param string $msg
     *
     * @return string
     */
	static public function html($msg)
	{
		$html = '' . $msg['msg'] . '(状态码：'.$msg['status'].')';
		$host = Url::get('');
		$file = DEVER_APP_PATH . 'config/html/404.html';
		if(is_file($file))
		{
			include($file);
			return;
		}
		include(DEVER_PATH . 'config/html/index.html');
	}
}