<?php namespace Dever\Http;

use Dever\Http\Output;
use Dever\Config\Load as Config;
use Dever\Config\Project;
use Dever\Routing\Uri;

class Url
{
	/**
     * config
     *
     * @var array
     */
    static public $config;

	/**
     * link
     * @param string $value
     *
     * @return array
     */
	static public function get($value = false, $project = false, $replace = false)
	{
		if($replace)
		{
			# 这里貌似暂时没啥用了。先保留吧。
			return str_replace('{'.$replace.'}', $value, Config::$global['host']['domain']);
		}
		
		if($value === false)
		{
			$value = Uri::$url ? Uri::$url : '';
		}

		# 为value增加默认参数
		if(isset(Config::$global['base']['url']) && Config::$global['base']['url'])
		{
			if(strpos($value, '?') === false)
			{
				$value .= '?' . Config::$global['base']['url'];
			}
			else
			{
				$value .= '&' . Config::$global['base']['url'];
			}
		}
		
		if(strpos($value, 'http://') !== false)
		{
			return $value;
		}

		$host = '';
		self::host($host, $value, $project);
		
		$key = $value;

		if(isset(self::$config['url']) && isset(self::$config['url'][$key]))
		{
			return self::$config['url'][$key];
		}

		Config::get('route', $project);

		if(Config::$global['route'])
		{
			if(strpos($value, '?') !== false)
			{
				$arg = explode('?', $value);
				$value = $arg[0];
			}

			if($uri = array_search($value, Config::$global['route']))
			{
				$value = $uri;
			}
			if(isset($arg[1]) && $arg[1])
			{
				parse_str($arg[1], $out);

				$str = $pre = '';
				$i = 1;
				self::$config['link_key'] = self::$config['link_value'] = array();
				self::$config['link_source'] = $arg[0];
				foreach($out as $k => $v)
				{
					if($i > 1)
					{
						$pre = '&';
					}
					$str .= $pre . $k . '=$' . $i;
					$i++;
					
					self::$config['link_key'][] = $k;
					self::$config['link_value'][] = $v;
				}
				
				self::$config['link_index'] = 0;

				$result = '';

				if($key = array_search($value . '?' . $str, Config::$global['route']))
				{
					$result = preg_replace_callback('/\(.*?\)/', 'self::link', $key);
				}

				if(!$result || $result == $value)
				{
					$value = $value . '?' . $arg[1];
				}
				else
				{
					$value = $result;
				}
			}
			else
			{
				$index = strpos($value, '?');
				if($index === false)
				{
					$value = preg_replace('/&/', '?', $value, 1);
				}
			}
		}

		if($value && isset(Config::$global['host']['workspace']) && strpos($host, Config::$global['host']['workspace']) !== false)
		{
			$path = str_replace(Config::$global['host']['workspace'], '', $host);
			if($path && strpos($value, $path) !== false)
			{
				$value = str_replace($path, '', $value);
			}
		}

		return self::$config['url'][$key] = $host  . Uri::$type . $value;
	}

	static private function host(&$host, &$value, &$project)
	{
		if(strpos($value, '/') !== false && (strpos($value, '.') !== false || strpos($value, '--') !== false))
		{
			$temp = explode('/', $value);
			$config = Project::load($temp[0]);
			if($config)
			{
				$value = $temp[1];
				$project = $temp[0];
				$host = $config['url'];
			}
			unset($temp);
		}
		elseif($project)
		{
			$config = Project::load($project);
			if($config)
			{
				$host = $config['url'];
			}
		}

		if(!$host)
		{
			$host = Config::$global['host']['base'];
		}
	}

	static private function link($param)
	{
		if(isset($param[0]) && $param[0] && isset(self::$config['link_value']) && isset(self::$config['link_value'][self::$config['link_index']]))
		{
			if(isset(Config::$global['host']['url_encode']))
			{
				$config = Config::$global['host']['url_encode'];
				if($config)
				{
					$filter = isset(Config::$global['host']['url_encode_filter']) ? Config::$global['host']['url_encode_filter'] : false;
					if($filter && self::$config['link_source'])
					{
						foreach($filter as $k => $v)
						{
							if(strpos(self::$config['link_source'], $v) !== false)
							{
								$config = false;
								break;
							}
						}
					}

					if($config && is_numeric(self::$config['link_value'][self::$config['link_index']]) && in_array(self::$config['link_key'][self::$config['link_index']], $config))
					{
						$method = Config::$global['host']['url_encode_method'][0];
						self::$config['link_value'][self::$config['link_index']] = $method(self::$config['link_value'][self::$config['link_index']]);
					}
				}
			}

			$param[0] = self::$config['link_value'][self::$config['link_index']];
		}
		self::$config['link_index']++;
		
		return $param[0];
	}

	/**
     * location
     * @param string $value
     *
     * @return mixed
     */
	static public function location($value, $type = 1)
	{
		if(strpos($value, 'http://') === false && strpos($value, 'https://') === false)
		{
			$value = self::get($value);
		}
		switch($type)
		{
			case 2 :
				$html = '<script>location.href="' . $value . '"</script>';
				Output::abert($html);
				die;
				break;

			default : 
				header('HTTP/1.1 301 Moved Permanently');
				header('Location: ' . $value);
				die;
				break;
		}
	}
}