<?php namespace Dever\Page;

use Dever\Http\Input;
use Dever\Config\Load as Config;
use Dever\Routing\Uri;
use Dever\Http\Url;

class Main
{
    /**
     * PAGE
     *
     * @var string
     */
    const PAGE = 'page/';
    
    /**
     * total
     *
     * @var int
     */
    public $total;

    /**
     * num
     *
     * @var int
     */
    public $num;

    /**
     * maxpage
     *
     * @var int
     */
    public $maxpage;

    /**
     * page
     *
     * @var int
     */
    public $page;

    /**
     * prev
     *
     * @var int
     */
    public $prev;

    /**
     * next
     *
     * @var int
     */
    public $next;

    /**
     * current
     *
     * @var int
     */
    public $current;

    /**
     * template
     *
     * @var string
     */
    public $template;

    /**
     * html
     *
     * @var string
     */
    public $html;
    
    /**
     * link
     *
     * @var string
     */
    public $link;
    
    /**
     * ext
     *
     * @var string
     */
    public $ext = '';

    /**
     * instance
     *
     * @var string
     */
    static protected $instance;

    /**
     * getInstance
     * 
     * @return Dever\Plad\Page;
     */
    static public function getInstance($key)
    {
        if(empty(self::$instance[$key]))
        {
            self::$instance[$key] = new self();
        }

        return self::$instance[$key];
    }

    /**
     * getPage
     * 
     * @return Dever\Plad\Page;
     */
    static public function getPage($key, $total = false, $template = '')
    {
        if(is_numeric($total) && $total > 0)
        {
            self::getInstance($key)->total($total);
            self::getInstance($key)->offset(1);
            self::getInstance($key)->template($key);
            self::getInstance($key)->link();
        }

        $result = self::getInstance($key)->handle($template);

        if($total == 'NEXT')
        {
            if(self::getInstance($key)->next)
            {
                $result = self::getInstance($key)->href(self::getInstance($key)->next);
            }
            else
            {
                $result = '';
            }
        }
        return $result;
    }

    /**
     * getTotal
     * 
     * @return Dever\Plad\Page;
     */
    static public function getTotal($key)
    {
        return self::getInstance($key)->total();
    }

    /**
     * getHtml
     * 
     * @return Dever\Plad\Page;
     */
    static public function getHtml($key, $template = '')
    {
        return self::getPage($key, false, $template);
    }

    /**
     * __construct
     *
     * @return mixd
     */
    private function __construct()
    {
        $this->maxpage = 10;
    }

    /**
     * getCurrent
     *
     * @return int
     */
    public function current($name = 'pg')
    {
        $this->current = Input::get($name, 1);

        return $this->current;
    }
    
    /**
     * getPage
     *
     * @return int
     */
    public function getAllPage()
    {
        if(!$this->total)
        {
            return 0;
        }
        $this->page = ceil($this->total / $this->num);

        return $this->page;
    }

    /**
     * offset
     *
     * @return int
     */
    public function offset($num)
    {
        $this->num = $num;

        $offset = $this->num * ($this->current()-1);
        
        return $offset;
    }

    /**
     * total
     *
     * @return mixd
     */
    public function total($total = false)
    {
        if(!$total)
        {
            return $this->total ? $this->total : 0;
        }
        
        $this->total = $total;
    }

    /**
     * maxpage
     *
     * @return mixd
     */
    public function maxpage($maxpage)
    {
        $this->maxpage = $maxpage;
    }

    /**
     * link
     *
     * @return mixd
     */
    public function link($link = '')
    {
        if(!$link) $link = Uri::$url;

        if(strpos($link, 'pg=') !== false)
        {
            $link = preg_replace('/[?|&]pg=(\d+)/i', '', $link);
        }

        if(strpos($link, 'pt=') !== false)
        {
            $link = preg_replace('/[?|&]pt=(\d+)/i', '', $link);
        }

        # search
        if(strpos($link, 'search_') === false)
        {
            $search = Input::prefix('search_');

            if($search)
            {
                $link .= '&' . http_build_query($search);
            }
        }
        
        $this->link = $link;
        
        return $this->link;
    }

    /**
     * template
     *
     * @return mixd
     */
    public function template($template)
    {
        $this->template = $template;
    }

    /**
     * data
     *
     * @return mixd
     */
    public function data($content, $total = 0)
    {
        $this->total = $total;
        if($content)
        {
            if($this->total <= 0)
            {
                $this->total = count($content);
            }

            $this->current();

            $data = isset($content[$this->current-1]) ? $content[$this->current-1] : array();
            
            return $data;
        }
        
        return array();
    }

    /**
     * count
     *
     * @return mixd
     */
    public function count($sql, $offset, $total = 0, $db)
    {
        $this->total = $total;
        $data_sql = $sql . ' LIMIT ' . $offset . ', ' . $this->num;
        $query = $db->query($data_sql);
        if($query)
        {
            $data = $db->query($data_sql)->fetchAll();

            if($this->total <= 0)
            {
                if(strstr($sql, 'from '))
                {
                    $temp = explode('from ', $sql);
                }
                if(strstr($sql, 'FROM '))
                {
                    $temp = explode('FROM ', $sql);
                }

                if(isset($temp[1]))
                {
                    if(strstr($temp[1], ' order '))
                    {
                        $temp = explode(' order ', $temp[1]);
                        $sql = $temp[0];
                    }
                    elseif(strstr($temp[1], ' ORDER '))
                    {
                        $temp = explode('ORDER', $temp[1]);
                        $sql = $temp[0];
                    }
                    else
                    {
                        $sql = $temp[1];
                    }
                    
                    $sql = 'SELECT count(1) as num FROM ' . $sql;
                    $this->total = $db->query($sql)->fetchColumn();
                }
            }
            
            return $data;
        }
        
        return array();
    }

    /**
     * handle
     *
     * @return mixd
     */
    public function handle($template = '')
    {
        if($this->total < 1)
        {
            return '';
        }

        # total page
        $this->getAllPage();
        //$this->page = ceil($this->total / $this->num);

        # current page
        if($this->page < $this->current)
        {
            $this->current = $this->page;
        }

        if($this->page <= 1)
        {
            return '';
        }

        if($this->total > $this->num)
        {
            if($this->current > 1)
            {
                $this->prev = $this->current-1;
            }

            if($this->current < $this->page)
            {
                $this->next = $this->current+1;
            }
            

            if($this->page <= $this->maxpage)
            {
                $this->start = 1;
                $this->end   = $this->page;
            }
            else
            {
                $page = intval($this->maxpage/2);
                if($this->current < $page)
                {
                    $this->start = 1;
                }
                elseif($this->current <= ($this->page - $this->maxpage))
                {
                    $this->start = $this->current - $page;
                }
                elseif($this->current > $this->page - $this->maxpage && $this->current <= $this->page - $page)
                {
                    $this->start = $this->current - $page;
                }
                elseif($this->current > $this->page - $page)
                {
                    $this->start = $this->page - $this->maxpage + 1;
                }
                $this->end = $this->start + $this->maxpage - 1;

                if($this->start < 1)
                {
                    $this->end = $this->current + 1 - $this->start;
                    $this->start = 1;
                    if(($this->end - $this->start) < $this->maxpage)
                    {
                        $this->end = $this->maxpage;
                    }
                }
                elseif($this->end > $this->page)
                {
                    $this->start = $this->page-$this->maxpage+1;
                    $this->end      = $this->page;
                }
            }
        }

        return $this->getTemplate($template);
    }

    /**
     * get
     *
     * @return string
     */
    public function getTemplate($template = '')
    {
        $template = $template ? $template : $this->template;
        $file = DEVER_APP_PATH . self::PAGE . $template . '.php';
        
        if(is_file($file))
        {
            $page = $this;

            include($file);

            return $page->get();
        }

        return '';
    }

    /**
     * get
     *
     * @return string
     */
    public function get()
    {
        return $this->html;
    }

    /**
     * html
     *
     * @return string
     */
    public function html($parent, $child, $prev = array('prev', 'prev'), $next = array('next', 'next'), $current = array('page','current', '', false), $start = false, $end = false, $jump = false, $ext = '')
    {
        if($ext)
        {
            $this->ext = $ext;
        }
        
        $html = '';

        if(empty($current[2]))
        {
            $current[2] = '';
        }

        if($start && $this->current > 1)
        {
            $html .= $this->set($child, $start[1], 1, $start[0], $current[2]);
        }

        if($this->prev)
        {
            # prev
            $html .= $this->set($child, $prev[1], $this->prev, $prev[0], $current[2]);
        }
        elseif(isset($prev[2]))
        {
            $html .= $this->set($child, $prev[1], $this->current, $prev[0], $current[2]);
        }
        

        if($current[1])
        {
            $i = $this->start;

            for($i; $i <= $this->end; $i++)
            {
                $class = $current[0];
                if($i == $this->current)
                {
                    if(isset($current[3]) && $current[3] == true)
                    {
                        $class = $current[1];
                    }
                    else
                    {
                        if($class) $class .= ' ';
                        $class .= $current[1];
                    }
                    
                }

                $html .= $this->set($child, $class, $i, $i, $current[2]);
            }
        }
        

        if($this->next)
        {
            # next
            $html .= $this->set($child, $next[1], $this->next, $next[0], $current[2]);
        }
        elseif(isset($next[2]))
        {
            $html .= $this->set($child, $next[1], $this->end, $next[0], $current[2]);
        }

        if($end && $this->current < $this->page)
        {
            $html .= $this->set($child, $end[1], $this->page, $end[0], $current[2]);
        }
        
        if($jump)
        {
            $click = 'onclick="var link=\''.$this->href('{1}').'\';location.href=link.replace(\'{1}\', document.getElementById(\'dever_page\').value)"';
            $html .= str_replace('{click}', $click, $jump);
        }

        $this->html = $this->tag($parent, $html);
    }

    /**
     * set
     *
     * @return string
     */
    public function set($child, $class, $num, $name, $type = '')
    {
        if($type == 'parent')
        {
            $child[1] = 'class="'.$class.'"';
            $class = '';
        }

        if($child[0] == 'a')
        {
            $child[1] = $this->attr($class, $this->href($num));
            $content = $name;
        }
        else
        {
            $content = $this->tag(array('a', $this->attr($class, $this->href($num))), $name);
        }

        return $this->tag($child, $content);
    }

    /**
     * tag
     *
     * @return string
     */
    public function tag($tag, $content)
    {
        if(!$tag)
        {
            return $content;
        }
        $attr = '';
        if(is_array($tag))
        {
            $temp = $tag;unset($tag);
            $tag = $temp[0];
            $attr = $temp[1];
        }
        return '<' . $tag . ' ' . $attr . '>' . $content . '</' . $tag . '>';
    }

    /**
     * next
     *
     * @return string
     */
    public function next()
    {
        return $this->current < $this->page ? $this->current+1 : $this->page;
    }

    /**
     * next
     *
     * @return string
     */
    public function prev()
    {
        return $this->current > 1 ? $this->current-1 : 1;
    }

    /**
     * href
     *
     * @return string
     */
    public function href($page = false)
    {
        $page = $page ? $page : $this->current;
        return Url::get($this->link . '&pg=' . $page . '&pt=' . $this->total) . $this->ext;
    }

    /**
     * attr
     *
     * @return string
     */
    public function attr($class, $href)
    {
        return ' class="'.$class.'" href="'.$href.'" ';
    }
}
