<?php namespace Dever\Routing;

use Dever;
use Dever\Template\View;
use Dever\Http\Output;
use Dever\Http\Input;
use Dever\Security\Api;
use Dever\Debug\Process as Debug;
use Dever\Config\Load as Config;
use Dever\Config\Project;
use Dever\Data\Opt;

class Route
{
	public function runing()
	{
		$uri = Uri::get();

		$state = self::def($uri);

		if(!$state && !self::api($uri))
		{
			//$key = Uri::url();

			$this->content = View::getInstance(Uri::file())->runing();
		}
		
		return $this;
	}

	private function def($uri)
	{
		if($uri == 'tcp.deamon')
		{
			\Dever\Server\Swoole::daemon();
			return true;
		}
		elseif($uri == 'rpc.server')
		{
			\Dever\Server\Rpc::init();
			return true;
		}

		return false;
	}

	public function api($uri)
	{
		if(strpos($uri, '.') !== false || strpos($uri, '-*') !== false || strpos($uri, '!') !== false)
		{
			# 不允许带有_的直接浏览器访问
			if(!defined('DEVER_DB_API') && strpos($uri, '._') !== false)
			{
				Output::abert('error_page');
			}

			Api::check($uri);

			$this->content = Load::get($uri, array());
			
			Api::out($this->content, true);
			
			return true;
		}
		
		return false;
	}

	public function output()
	{
		if(!isset($this->content))
		{
			return;
		}

		if(!$this->content)
		{
			Output::abert('error_page');
		}

		if(Project::load('manage'))
		{
			if(isset(Config::$global['base']['cron']) && Config::$global['base']['cron'] && DEVER_TIME%2 == 0)
			{
				Dever::load('manage/project.cron');
			}
			
			if(isset(Config::$global['base']['opt']))
			{
				Opt::record();
			}
		}
		
		echo Output::result($this->content, false, false);

		$this->debug();

		die;
	}

	private function debug()
	{
		if(Debug::init() && is_string($this->content))
		{
			Debug::out();
		}
	}
}