<?php namespace Dever\Routing;

use Dever\Security\Api;
use Dever\Config\Load as Config;
use Dever\Session\Save;
use Dever\Http\Output;
use Dever\Http\Input;

class Step
{
    static protected $step;
    static protected $key;
    static protected $method;
    static protected $save;
    static protected $check = 'step_signature';
    static protected $time = 500;

    static public function init($method, $step, $key, $class)
    {
    	self::$save = new Save();
    	self::$step = $step;
    	self::$key = $key;
    	self::$method = $method . $key;
        if(self::$step == 1)
        {
        	self::create();
        }
        else
        {
        	self::check();
        	self::create();
        }
    }

    static private function create()
    {
    	$input = Input::prefix('step_');
    	$param = $input + array('method' => self::$method . (self::$step + 1));

        Config::$global['step'][self::$step] = Api::get($param);
		self::$save->add(self::$check, Config::$global['step'][self::$step]['signature'], self::$time);
    }

    static private function check()
    {
    	$input = Input::prefix('step_');
    	$param = $input + array('method' => self::$method . self::$step);

        $signature = Api::result($param);

        $save = self::$save->get(self::$check);

        if($signature != $save)
        {
        	Output::abert('api_signature_exists');die;
        }
        else
        {
        	self::$save->un(self::$check);
        }
    }

    static public function set($value)
    {
    	self::$save->add('data_' . (self::$step+1), $value, self::$time);
    }

    static public function get()
    {
    	return self::$save->get('data_' . self::$step);
    }
}