<?php namespace Dever\Routing;

use Dever\Config\Load as Config;
use Dever\Http\Input;

class Uri
{
	/**
     * explode
     *
     * @var string
     */
    const explode =  '/';
    
	/**
	 * uri value
	 *
	 * @var string
	 */
	static public $value;

	/**
	 * method
	 *
	 * @var string
	 */
	static public $method;
	
	/**
	 * uri type
	 *
	 * @var string
	 */
	static public $type = '?';
	
	/**
	 * url
	 *
	 * @var string
	 */
	static public $url;

	static public function get()
	{
		if(self::$value) return self::$value;

		self::info();
		
		self::request();

		self::$method = isset($_SERVER['REQUEST_METHOD']) ? $_SERVER['REQUEST_METHOD'] : 'GET';

		if(!self::$url && Input::$term == true && Input::get('send'))
		{
			self::$url = self::$value = str_replace(array('__', '^'), array('?', '&'), Input::get('send'));
		}

		empty(self::$value) && self::$value = 'home';

		self::match();
		
		return self::$value;
	}

	static private function info()
	{
		if(isset($_SERVER['PATH_INFO']))
		{
			self::$type = '';

			self::$value = trim($_SERVER['PATH_INFO'], self::explode);

			self::$url = preg_replace('/^\//i', '', $_SERVER['REQUEST_URI']);
		}
	}

	static private function request()
	{
		if(!isset($_SERVER['PATH_INFO']) && isset($_SERVER['REQUEST_URI']) && $_SERVER['REQUEST_URI'] && $_SERVER['REQUEST_URI'] != '/')
		{
			self::$type = '?';
			$script = substr($_SERVER['SCRIPT_NAME'], 0, strpos($_SERVER['SCRIPT_NAME'], 'index.php'));

			if(strpos($_SERVER['REQUEST_URI'], '/index.php') !== false)
			{
				self::$value = str_replace($_SERVER['SCRIPT_NAME'] . '?', '', $_SERVER['REQUEST_URI']);
			}
			elseif($script != $_SERVER['REQUEST_URI'])
			{
				self::$value = str_replace($script . '?', '', $_SERVER['REQUEST_URI']);
			}
			self::$url = self::$value;
		}
	}

	static public function match()
	{
		Config::get('route');

		self::input();
		
		if(Config::$global['route'] && self::$value)
		{
			if(isset(Config::$global['route'][self::$value]))
			{
				self::$value = Config::$global['route'][self::$value];
			}
			else
			{
				self::grep();
			}
		}
	}

	static private function grep()
	{
		foreach(Config::$global['route'] as $k => $v)
		{
			$k = str_replace(':any', '.+', str_replace(':num', '[0-9]+', $k));

            if(preg_match('#^'.$k.'$#', self::$value))
            {
                if(strpos($v, '$') !== false && strpos($k, '(') !== false)
                {
                	$v = preg_replace('#^'.$k.'$#', $v, self::$value);
                }

                self::$value = $v;

                self::$url = self::$value;
            }
		}
		self::input();
	}

	static private function input()
	{
		if(strpos(self::$value, '?') !== false)
		{
			$temp = explode('?', self::$value);
			self::$value = $temp[0];
			parse_str($temp[1], $input);
			Input::set('all', $input);

			if(Input::$term == true && isset($input['dever_server']))
			{
				$_SERVER['DEVER_SERVER'] = $input['dever_server'];
			}
		}
	}

	static public function file()
	{
		self::tain();

		if(strpos(self::$value, self::explode) !== false)
		{
			$array = explode(self::explode, self::$value);
			
			$file = self::parse($array);
			
			//$param = array_values($array);
		}
		else
		{
			$file = self::$value;
		}
		
		return $file;
	}

	static public function url()
	{
		return self::$url;
	}

	static private function tain()
	{
		if(self::$method == 'GET' && !empty($_SERVER['REQUEST_URI']))
		{
			$request_uri = strtoupper(urldecode($_SERVER['REQUEST_URI']));
			if(strpos($request_uri, '<') !== false || strpos($request_uri, '"') !== false || strpos($request_uri, 'CONTENT-TRANSFER-ENCODING') !== false)
			{
				error(\Lang::get('request_tainting'));
			}
			unset($request_uri);
		}
	}

	static private function parse(&$array)
	{
		if(isset($array[2]) && empty($array[3]))
		{
			$file = $array[0] . self::explode . $array[1] . self::explode . $array[2];
			unset($array[0]);
			unset($array[1]);
			unset($array[2]);
		}
		elseif(isset($array[1]))
		{
			$file = $array[0] . self::explode . $array[1];
			unset($array[0]);
			unset($array[1]);
		}
		elseif(isset($array[0]))
		{
			$file = $array[0];
			unset($array[0]);
		}

		return $file;
	}
}