<?php namespace Dever\Security;

class String
{
    static public function rule($method)
	{
		$method = 'rule_' . $method;
		return self::$method();
	}

	static public function rule_mobile()
	{
		return '/^(1(([358][0-9])|(45)|(47)))\d{8}$/';
	}

	static public function rule_email()
	{
		return '/^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/';
	}

	static public function rand($len, $type = 4)
	{
		$source = array("0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z");

		$config = array
		(
			0 => array("min" => 0,"max" => 9),	/// 全数字
			1 => array("min" => 10,"max" => 35),	/// 全小写
			2 => array("min" => 36,"max" => 61),	/// 全大写
			3 => array("min" => 10,"max" => 61),	/// 大小写
			4 => array("min" => 0,"max" => 61),	/// 数字+大小写
		);
		if(!isset($config[$type]))
		{
			$type = 4;
		}

		$rand = "";
		for($i=0;$i<$len;$i++)
		{
			$rand .= $source[rand($config[$type]["min"], $config[$type]["max"])];
		}

		return $rand;
	}

	static public function xss($data)
	{
		if(!is_string($data))
		{
			return $data;
		}
		$data = str_replace(array('&amp;','&lt;','&gt;'), array('&amp;amp;','&amp;lt;','&amp;gt;'), $data);
		$data = preg_replace('/(&#*\w+)[\x00-\x20]+;/u', '$1;', $data);
		$data = preg_replace('/(&#x*[0-9A-F]+);*/iu', '$1;', $data);
		$data = html_entity_decode($data, ENT_COMPAT, 'UTF-8');

		// Remove any attribute starting with "on" or xmlns
		$data = preg_replace('#(<[^>]+?[\x00-\x20"\'])(?:on|xmlns)[^>]*+>#iu', '$1>', $data);

		// Remove javascript: and vbscript: protocols
		$data = preg_replace('#([a-z]*)[\x00-\x20]*=[\x00-\x20]*([`\'"]*)[\x00-\x20]*j[\x00-\x20]*a[\x00-\x20]*v[\x00-\x20]*a[\x00-\x20]*s[\x00-\x20]*c[\x00-\x20]*r[\x00-\x20]*i[\x00-\x20]*p[\x00-\x20]*t[\x00-\x20]*:#iu', '$1=$2nojavascript...', $data);
		$data = preg_replace('#([a-z]*)[\x00-\x20]*=([\'"]*)[\x00-\x20]*v[\x00-\x20]*b[\x00-\x20]*s[\x00-\x20]*c[\x00-\x20]*r[\x00-\x20]*i[\x00-\x20]*p[\x00-\x20]*t[\x00-\x20]*:#iu', '$1=$2novbscript...', $data);
		$data = preg_replace('#([a-z]*)[\x00-\x20]*=([\'"]*)[\x00-\x20]*-moz-binding[\x00-\x20]*:#u', '$1=$2nomozbinding...', $data);

		// Only works in IE: <span style="width: expression(alert('Ping!'));"></span>
		$data = preg_replace('#(<[^>]+?)style[\x00-\x20]*=[\x00-\x20]*[`\'"]*.*?expression[\x00-\x20]*\([^>]*+>#i', '$1>', $data);
		$data = preg_replace('#(<[^>]+?)style[\x00-\x20]*=[\x00-\x20]*[`\'"]*.*?behaviour[\x00-\x20]*\([^>]*+>#i', '$1>', $data);
		$data = preg_replace('#(<[^>]+?)style[\x00-\x20]*=[\x00-\x20]*[`\'"]*.*?s[\x00-\x20]*c[\x00-\x20]*r[\x00-\x20]*i[\x00-\x20]*p[\x00-\x20]*t[\x00-\x20]*:*[^>]*+>#iu', '$1>', $data);

		// Remove namespaced elements (we do not need them)
		$data = preg_replace('#</*\w+:\w[^>]*+>#i', '', $data);

		do {
		// Remove really unwanted tags
			$old_data = $data;
			$data = preg_replace('#</*(?:applet|b(?:ase|gsound|link)|embed|frame(?:set)?|i(?:frame|layer)|l(?:ayer|ink)|meta|object|s(?:cript|tyle)|title|xml)[^>]*+>#i', '', $data);
		}
		while ($old_data !== $data);

		// we are done...
		return $data;
	}

	static public function idtostr($input)
	{
		if(!is_numeric($input) || $input < 0)
		{
			return false;
		}

		$input = substr("00000000".$input, -8);
		$sandNum =  $input % 10;
		srand($input);
		$randstr = "".rand(1,9).common_RandStr(7,0);

		$retstr1 = "";
		$retstr2 = "";
		for($i=0;$i<4;$i++)
		{
			$retstr1 .= $randstr[$i] . $input[$i];
			$retstr2 .= $input[7-$i] . $randstr[7-$i];
		}
		$retstr1 = substr(common_RandStr(6)."g".dechex($retstr1),-7);
		$retstr2 = substr(common_RandStr(6)."g".dechex($retstr2),-7);
		srand(time()+$input);
		$retstr = "1".$sandNum;
		for ($i = 0; $i < 7; $i++)
		{
			$retstr .=$retstr1[$i].$retstr2[$i];
		}
		return $retstr;
	}

	static public function strtoid($str)
	{
		if(strlen($str) != 16)
		{
			return $str;
		}
		$type = $str1[0];

		$sandNum = $str[1];

		for ($i = 0; $i < 7; $i++)
		{
			if($str[2+$i*2] == 'g')
			{
				$retstr1 = "";
			}
			else
			{
				$retstr1 .= $str[2+$i*2];
			}

			if($str[3+$i*2] == 'g')
			{
				$retstr2 = "";
			}
			else
			{
				$retstr2 .= $str[3+$i*2];
			}
		}

		$retstr1 = "g".substr("00000000".hexdec($retstr1),-8);
		$retstr2 = "g".substr("00000000".hexdec($retstr2),-8);
		$ret1 = $ret2 = "";
		for ($i = 0; $i < 4; $i++)
		{
			$ret1 .= $retstr1[$i*2+2];
			$ret2 .= $retstr2[7-$i*2];
		}
		$ret = $ret1 * 10000 + $ret2;
		return $ret;
	}
}